<?php
header('Content-Type: application/json; charset=UTF-8');
header("Access-Control-Allow-Origin: *");
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


include "config.php";
date_default_timezone_set("Asia/Kolkata");

// // Check if it's a preflight request and respond with 200 OK
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(200);
    exit;
}


// Initialize an array to store the result data
$tdata = array();

// Query to fetch checkout data
$tsql = "SELECT gb.*, u.name, u.phone, u.g_percent, u.address
        FROM gold_booking gb
        JOIN users u ON gb.uid = u.id";

$tresult = mysqli_query($conn, $tsql);
if ($tresult) {
    while ($trow = mysqli_fetch_assoc($tresult)) {
        // Fetch order details for each checkout
       

        // Prepare data for response
        $data = array(
            "id" => $trow['id'],
            "orderid" => $trow['oid'],
            "price" => $trow['total'],
            "date" => $trow['date'],
            "item_count" => $count,
            "advance" => $trow['advance'],
            "name" => $trow['name'],
            "metal" => $trow['metal'],
            "city" => $trow['city'],
            "paymethod" => $trow['pmode'],
            "st" => $trow['status'],
            "weight" => $trow['weight'],
            "percent" => $trow['percent'],
            "mobile" => $trow['phone'],
            "remark" => $trow['remark'],
            "ref" => $trow['ref'],
            "mprice" => $trow['m_price']
        );

        // Add data to the result array
        $tdata[] = $data;
    }

    // Check if any data is fetched
    if (!empty($tdata)) {
        echo json_encode(["message" => "radha", "result" => $tdata]);
    } else {
        echo json_encode(["message" => "No transactions found", "result" => []]);
    }
} else {
    // Error handling if query fails
    echo json_encode(["message" => "Error executing query", "result" => []]);
}

// Close database connection
// mysqli_close($conn);
?>
