<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include 'config.php'; // Include your database configuration

// Get POST data
$data = json_decode(file_get_contents("php://input"), true);
$bill_id = isset($data['bill_id']) ? intval($data['bill_id']) : 0; // Changed user_id to bill_id
$amount = isset($data['amount']) ? floatval($data['amount']) : 0; // Cast to float for security

$conn->begin_transaction();

try {
    // Update the bills table
    $query = "
        UPDATE bills 
        SET 
            remain_amount = remain_amount - $amount, 
            total_amount = total_amount + $amount 
        WHERE 
            id = $bill_id 
            AND remain_amount > 0
    ";

    // Execute the update query
    if ($conn->query($query) === TRUE) {
        // Insert into bill_transaction
        $insertQuery = "
            INSERT INTO bill_transaction (bill_id, user_id, amount, `by`, `date`) 
            VALUES ($bill_id, '', $amount, '1', NOW())"; // Adjust 'your_value_for_by' accordingly
        
        if ($conn->query($insertQuery) === TRUE) {
            // Commit the transaction if both queries succeed
            $conn->commit();
            echo json_encode(["success" => true]);
        } else {
            // Rollback the transaction if insertion fails
            $conn->rollback();
            echo json_encode(["success" => false, "message" => "Transaction insertion failed"]);
        }
    } else {
        // Rollback the transaction on update failure
        $conn->rollback();
        echo json_encode(["success" => false, "message" => "Payment update failed"]);
    }
} catch (Exception $e) {
    // Rollback the transaction in case of error
    $conn->rollback();
    echo json_encode(["success" => false, "message" => "Error: " . $e->getMessage()]);
} finally {
    $conn->close();
}
