<?php

header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include "config.php";
date_default_timezone_set("Asia/Kolkata");

// Get the raw POST data and decode it as JSON
$data = json_decode(file_get_contents("php://input"), true);

// Validate and sanitize the inputs
$id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : "";
$name = isset($data['proname']) ? mysqli_real_escape_string($conn, $data['proname']) : "";
$category = isset($data['category']) ? intval($data['category']) : 0;
$collection = isset($data['collection']) ? intval($data['collection']) : 0;
$stock = isset($data['stock']) ? mysqli_real_escape_string($conn, $data['stock']) : "";
$code = isset($data['code']) ? mysqli_real_escape_string($conn, $data['code']) : "";
$desc = isset($data['desc']) ? mysqli_real_escape_string($conn, $data['desc']) : "";
$gender = isset($data['gender']) ? mysqli_real_escape_string($conn, $data['gender']) : "";
$st = isset($data['status']) ? intval($data['status']) : 0;
$price = isset($data['price']) ? mysqli_real_escape_string($conn, $data['price']) : "";
$discount = isset($data['discount']) ? mysqli_real_escape_string($conn, $data['discount']) : "";
$net = isset($data['net']) ? mysqli_real_escape_string($conn, $data['net']) : "";
$gross = isset($data['gross']) ? mysqli_real_escape_string($conn, $data['gross']) : "";
$dgm = isset($data['d_gm']) ? mysqli_real_escape_string($conn, $data['d_gm']) : "";
$dkarat = isset($data['d_karat']) ? mysqli_real_escape_string($conn, $data['d_karat']) : "";

// Handle file uploads from $_FILES
$target_dir = "../../../ImagesWeb/Products/";
$file_paths1 = "";
$file_paths2 = "";
$file_paths3 = "";

// Check if files are uploaded
if (isset($_FILES["images"])) {
    $file_paths = [];
    
    foreach ($_FILES["images"]["tmp_name"] as $index => $tmp_name) {
        // Generate a unique filename for each uploaded file
        $unique_filename = "product_" . uniqid() . '.' . pathinfo($_FILES["images"]["name"][$index], PATHINFO_EXTENSION);
        $target_file = $target_dir . basename($unique_filename);

        if (move_uploaded_file($tmp_name, $target_file)) {
            $file_paths[] = $unique_filename;
        } else {
            echo json_encode(["message" => "Error moving uploaded file to destination"]);
            exit;
        }
    }

    // Assign file paths to variables
    $file_paths1 = isset($file_paths[0]) ? $file_paths[0] : "";
    $file_paths2 = isset($file_paths[1]) ? $file_paths[1] : "";
    $file_paths3 = isset($file_paths[2]) ? $file_paths[2] : "";
}

if (!empty($name)) {
    // Insert or update the product data
    if (empty($id)) {
        // Insert new product
        $sql = "INSERT INTO `products` (`name`, `active`, `stock`, `code`, `category`, `price`, `dis_price`, `description`, `img`, `img1`, `img2`, `net`, `gross`, `d_gm`, `d_karat`, `type`, `gender`) 
                VALUES ('$name', '$st', '$stock', '$code', '$category', '$price', '$discount', '$desc', '$file_paths1', '$file_paths2', '$file_paths3', '$net', '$gross', '$dgm', '$dkarat', '$collection', '$gender')";
    } else {
        // Update existing product
        if (empty($file_paths1)) {
            // Update without changing images
            $sql = "UPDATE `products` SET 
                    `name`='$name', `active`='$st', `stock`='$stock', `code`='$code', `category`='$category', 
                    `net`='$net', `gross`='$gross', `gender`='$gender', `description`='$desc', `d_gm`='$dgm', 
                    `d_karat`='$dkarat', `dis_price`='$discount', `price`='$price', `type`='$collection' 
                    WHERE `id`='$id'";
        } else {
            // Update with new images
            $sql = "UPDATE `products` SET 
                    `name`='$name', `active`='$st', `stock`='$stock', `code`='$code', `category`='$category', 
                    `img`='$file_paths1', `img1`='$file_paths2', `img2`='$file_paths3', 
                    `net`='$net', `gross`='$gross', `gender`='$gender', `description`='$desc', `d_gm`='$dgm', 
                    `d_karat`='$dkarat', `dis_price`='$discount', `price`='$price', `type`='$collection' 
                    WHERE `id`='$id'";
        }
    }

    $run = mysqli_query($conn, $sql);

    if ($run) {
        echo json_encode(["message" => "Success", "sql" => $sql]);
    } else {
        echo json_encode(["message" => "Error inserting data: " . mysqli_error($conn)]);
    }
} else {
    echo json_encode(["message" => "Name is required"]);
}

?>
