<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(200);
    exit;
}
include "config.php";
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);
$limit = $_POST['limit'] == "20" ? "20"  : "16";
// if(!empty($_POST['pid'] && ))
$pid = isset($_POST['pid']) ? $_POST['pid'] : "";
$indexFrom = isset($_POST['indexFrom']) ? $_POST['indexFrom'] : 0;
$uid = isset($_POST['uid']) ? $_POST['uid'] : "";
function safeEscape($conn, $value)
{
    return mysqli_real_escape_string($conn, $value);
}

$category = isset($_POST['cat']) ? $_POST['cat'] : array();
$collection = isset($_POST['collection']) ? $_POST['collection'] : array();
$material = isset($_POST['material']) ? $_POST['material'] : array();
$pricess = isset($_POST['price']) ? $_POST['price'] : null;
$gender = isset($_POST['gender']) ? $_POST['gender'] : null;
$sort = isset($_POST['sort']) ? $_POST['sort'] : null;
$occassion = isset($_POST['occassion']) ? $_POST['occassion'] : array();

function convertStringToArray($_POSTString)
{
    return explode(",", $_POSTString);
}

$categoryArray = $category;
$collectionArray = $collection;
$materialArray = $material;
$priceArray = $pricess;
$genderArray = $gender;
$occassionArray = $occassion;

$data = array();

if ($pid != null) {
    $query = "SELECT * FROM `products` WHERE `id`=$pid AND `active`= 0";
} else {
       

$query = "SELECT * FROM `products` WHERE `active`= 0 AND `stock`>0";

if (!empty($categoryArray)) {
    $categoryConditions = array();
    foreach ($categoryArray as $category) {
        
        $escapedCategory = safeEscape($conn, $category);
        $sql = "SELECT * FROM `category` WHERE `name`='$escapedCategory'";
        $crow = mysqli_query($conn, $sql);
        $crun = mysqli_fetch_array($crow);
        $id = $crun['id'];
        $categoryConditions[] = "`category` = '$id'";
    }
    $query .= " AND (" . implode(" OR ", $categoryConditions) . ")";
}

if (!empty($collectionArray)) {
        $collectionConditions = array();
        $query .= " AND `id` IN (SELECT `proid` FROM `collectioncon` WHERE";

        foreach ($collectionArray as $collection) {
            $escapedCollection = safeEscape($conn, $collection);
            $sql = "SELECT * FROM `collection` WHERE `name`='$escapedCollection'";
            $crow = mysqli_query($conn, $sql);
            $crun = mysqli_fetch_array($crow);
            $id = $crun['id'];  
            $collectionConditions[] = " `collid`='$id'";
        }
        $query .= " (" . implode(" OR ", $collectionConditions) . "))";
}


if (!empty($occassionArray)) {
        $occassionConditions = array();
        $query .= " AND `id` IN (SELECT `proid` FROM `occassioncon` WHERE";

        foreach ($occassionArray as $occassion) {
            $escapedOccassion = safeEscape($conn, $occassion);
            $sql = "SELECT * FROM `occassion` WHERE `name`='$escapedOccassion'";
            $crow = mysqli_query($conn, $sql);
            $crun = mysqli_fetch_array($crow);
            $id = $crun['id'];  
            $occassionConditions[] = " `occid`='$id'";
        }
        $query .= " (" . implode(" OR ", $occassionConditions) . "))";
}

// if (!empty($materialArray)) {
//     $materialConditions = array();
//     foreach ($materialArray as $material) {
//         $escapedMaterial = safeEscape($conn, $material);
//         $materialConditions[] = "`material` = '$escapedMaterial'";
//     }
//     $query .= " AND (" . implode(" OR ", $materialConditions) . ")";
// }


if (!empty($materialArray)) {
    $materialConditions = array();
    foreach ($materialArray as $material) {
        $escapedMaterial = safeEscape($conn, $material);
        $sql = "SELECT * FROM `material` WHERE `name`='$escapedMaterial'";
        $crow = mysqli_query($conn, $sql);
        $crun = mysqli_fetch_array($crow);
        $id = $crun['id'];
        $materialConditions[] = "`type` = '$id'";
    }
    $query .= " AND (" . implode(" OR ", $materialConditions) . ")";
}

if (!empty($priceArray)) {
    list($minPrice, $maxPrice) = explode('-', $priceArray);
    $minPrice = safeEscape($conn, $minPrice);
    $maxPrice = safeEscape($conn, $maxPrice);
    
    $priceCondition = "`price` BETWEEN $minPrice AND $maxPrice";

    $query .= " AND ($priceCondition)";
}

if (!empty($genderArray)) {

        $escapedGender = safeEscape($conn, $gender);
        $genderConditions= "`gender` = '$escapedGender' OR `gender`='Unisex'";
    $query .= " AND ( $genderConditions)";
}

switch ($sort) {
    case "latest":
        $query .= " ORDER BY `id` DESC";
        break;
    case "abc":
        $query .= " ORDER BY `name` ASC";
        break;
    case "xyz":
        $query .= " ORDER BY `name` DESC";
        break;
    case "lowhigh":
        $query .= " ORDER BY `price` ASC";
        break;
    case "highlow":
        $query .= " ORDER BY `price` DESC";
        break;
    default:
        $query .= " ORDER BY `id` DESC";
}
if($limit != "20"){
$query .= " LIMIT $indexFrom, $limit";
}
}
$result = mysqli_query($conn, $query);
// echo $query;
if (!$result) {
    $error = "Error: " . mysqli_error($conn);
    echo json_encode(["message" => $query]);
} else {
    while ($row = mysqli_fetch_assoc($result)) {
        $productId = $row['id'];
        $net = $row['net'];
        $gross = $row['gross'];
        $dgm = $row['d_gm'];
        $dkarat = $row['d_karat'];
        $material = $row['type'];
        $pprice = $row['price'];
        $mQuery = "SELECT * FROM material WHERE id='$material'";
        $mResult = mysqli_query($conn, $mQuery);
        $mrow = mysqli_fetch_array($mResult);
        $mname = $mrow['name'];
        $mprice = $mrow['price'];
        $dprice = $row['dprice'];
        $dname = $row['diamond'];
        $dtotal = round($dprice) ;

        if($material == 3){
            if($net > 2.000 && $net <5.000){
              $making = 600; 
            }else if($net > 5.000 && $net < 10.000){
              $making = 700;
            }else if($net > 10.000 && $net < 15.000){
              $making = 800 ;
            }else if($net > 15.000 && $net < 20.000){
              $making = $net*60 ;
            }else if($net > 20.000 && $net < 25.000){
              $making = $net*50 ;
            }else if($net > 25.000){
              $making = $net*40 ;
            }
            $mm = $making/2;
            $ggg = $net*$mprice+$mm+$dtotal;
            $gst = round($ggg*0.03);
            $price = round($net*$mprice+$mm+$gst+$dtotal);
            $discount = round($net*$mprice+$making+$gst+$dtotal);
        }else if($material == 8){
            if($net > 0.000 && $net <0.500){
              $making = $net*1400; 
            }else if($net > 0.510 && $net < 0.800){
              $making = $net*1650;
            }else if($net > 0.810 && $net < 1.000){
              $making = $net*2050 ;
            }else if($net > 1.010 && $net < 1.400){
              $making = $net*2350 ;
            }else if($net > 1.410 && $net < 1.900){
              $making = $net*2600 ;
            }else if($net > 1.910 && $net < 2.200){
              $making = $net*2850 ;
            }else {
              $making = $net*1500;
            }
            $mm = $making/2;
            $ggg = $net*$mprice+$mm+$dtotal;
            $gst = round($ggg*0.03);
            $price = round($net*$mprice+$mm+$gst+$dtotal);
            $discount = round($net*$mprice+$making+$gst+$dtotal);
        }else{
            $p = $row['price'];
            $fgst = $row['price']*0.03;
            $pp = $row['price'] + $fgst;
            $price = $pp;
            $discount = $row['dis_price'] + $row['dis_price']*0.03;
        }
        
        
      

        $cartCheckQuery = "SELECT * FROM cart WHERE pid='$productId' AND uid='$uid'";
        $cartCheckResult = mysqli_query($conn, $cartCheckQuery);
        $row['in_cart'] = ($cartCheckResult && mysqli_num_rows($cartCheckResult) > 0) ? true : false;
        
        $wishlistCheckQuery = "SELECT * FROM wishlist WHERE pid='$productId' AND uid='$uid'";
        $wishlistCheckResult = mysqli_query($conn, $wishlistCheckQuery);
        $row['in_wishlist'] = ($wishlistCheckResult && mysqli_num_rows($wishlistCheckResult) > 0) ? true : false;
        
        // Add images to the images array
        $images = array();
        $images[] = array("image_id" => 1101, "id" => 1.1, "alt" => "yellow", "src" => $imgpath."/Products/" . $row['img']);
        $images[] = array("image_id" => 1111, "id" => 1.1, "alt" => "yellow", "src" => $imgpath."/Products/" . $row['img1']);
        $images[] = array("image_id" => 1121, "id" => 1.2, "alt" => "white", "src" => $imgpath."/Products/" . $row['img2']);
      
        
        // Add the product data to the data array
        $data[] = array(
            "hasMore" => true,
            "id" => $row['id'],
            "img" => $imgpath."/Products/" . $row['img'],
            "price" => round($price),
            "title" => $row['name'],
            // "src" => $src,
            "new" => true,
            "sale" => true,
            "discount" => round($discount),
            "category" => $row['category'],
            // "collection" =>  $row['collection'],
            "desc" => $row['description'],
            "labour" => $mm,
            "mprice" => $mprice*$net,
            "total_price" =>  round($price) ,
            "type" => $pprice,
            "images" => $images,   
            "net" => $net,
            "gross" => $gross,
            "gst" => round($gst),
            "d_gm" => $dgm,
            "d_karat" => $dkarat,
            "dname" => $dname,
            "dprice" => $dprice,
            "dtotal" => $dtotal,
            "variants" => $images,
            "materialtype" => $material,
            "tags" => array("s", "l", "white", "skyblue", "madame"),
            "brand" => $mname,
            "cart" => $row['in_cart'],
            "wishlist" => $row['in_wishlist'],
            "material" => $mname,
            "stock" => $row['stock']
        );
    }
    // mysqli_free_result($result);
    
    // Return JSON response
    $totalCount = count($data);
    if ($totalCount > 0) {
        echo json_encode(["message" => "radha", "result" => $data, "total" => $totalCount]);
    } else {
        echo json_encode(["message" => "No Products For Specific Search", "total" => $totalCount]);
    }
}
?>
