<?php
include "config.php";

// Retrieve the webhook payload
$payload = file_get_contents('php://input');
$data = json_decode($payload, true);

// Secret key (make sure this matches the one in your webhook configuration)
$secret = 'guruXmanglik'; // replace with your actual secret

// Verify the payload using the secret
if (isset($_SERVER['HTTP_X_HMAC_SHA256'])) {
    $received_hash = $_SERVER['HTTP_X_HMAC_SHA256'];
    $calculated_hash = base64_encode(hash_hmac('sha256', $payload, $secret, true));

    if (hash_equals($calculated_hash, $received_hash)) {
        // Verify the payload
        if (isset($data['awb_number']) && isset($data['status']) && isset($data['event_time'])) {
            $awb_number = $conn->real_escape_string($data['awb_number']);
            $status = $conn->real_escape_string($data['status']);
            $event_time = $conn->real_escape_string($data['event_time']);
            $location = isset($data['location']) ? $conn->real_escape_string($data['location']) : null;
            $message = isset($data['message']) ? $conn->real_escape_string($data['message']) : null;
            $rto_awb = isset($data['rto_awb']) ? $conn->real_escape_string($data['rto_awb']) : null;

            // Insert data into the database
            $sql = "INSERT INTO shipment_events (awb_number, status, event_time, location, message, rto_awb)
                    VALUES ('$awb_number', '$status', '$event_time', '$location', '$message', '$rto_awb')";

            if ($conn->query($sql) === TRUE) {
                http_response_code(200);
                echo json_encode(["message" => "Data stored successfully"]);
            } else {
                http_response_code(500);
                echo json_encode(["message" => "Error: " . $sql . "<br>" . $conn->error]);
            }
        } else {
            http_response_code(400);
            echo json_encode(["message" => "Invalid payload"]);
        }
    } else {
        http_response_code(403);
        echo json_encode(["message" => "Invalid signature"]);
    }
} else {
    http_response_code(400);
    echo json_encode(["message" => "Missing signature"]);
}

$conn->close();
?>
