<?php
require("utils/MiddleWare.php");

// Check if 'srch' and 'page' are set in the request
if (isset($req['srch']) && isset($req['page'])) {
    $str = $req['srch']; // input data for search
    $n = trim($str);
    $page = $req['page']; // page validation

    // Define the user query based on the page value
    switch ($page) {
        case "AddMoney":
        case "CreateLoan":
        case "AddExtraCharge":
        case "Withdraw":
            $userquery = "SELECT * FROM `mandal_user` WHERE `id` LIKE '%$n%'";
            break;

        case "AddSakhiMoney":
        case "SakhiCreateLoan":
        case "AddSakhiExtraCharge":
            $userquery = "SELECT * FROM `sakhi_user` WHERE `id` LIKE '%$n%'";
            break;
            
         case "witness1":
         case "witness2":
            $userquery = "SELECT * FROM `sakhi_user` WHERE `lid`=0 AND `name` LIKE '%$n%'";
            break;

        case "DhanCreateLoan":
            $userquery = "SELECT * FROM `dhan_user` WHERE `id` LIKE '%$n%'";
            break;

        case "CreateMember":
        case "CreateDhan":
        case "CreateSakhi":
        case "":
            $userquery = "SELECT * FROM `users` WHERE `name` LIKE '%$n%' OR `phone` LIKE '%$n%'";
            break;

        case "AddEmi":
            $userquery = "SELECT t.*, u.name, u.id AS id, t.loan_amount AS phone
                          FROM loan t 
                          JOIN mandal_user u ON t.mid = u.id 
                          WHERE t.remaining != 0 
                          AND (t.mid LIKE '%$n%')";
            break;

        case "AddSakhiEmi":
            $userquery = "SELECT t.*, u.name, u.id AS id, t.loan_amount AS phone
                          FROM sakhi_loan t 
                          JOIN sakhi_user u ON t.sid = u.id 
                          WHERE t.remaining != 0 
                          AND (t.sid LIKE '%$n%')";
            break;

        case "AddDhanEmi":
            $userquery = "SELECT t.*, u.name, u.id AS id, t.amount AS phone
                          FROM dhan_loan t 
                          JOIN dhan_user u ON t.did = u.id 
                          WHERE t.remain != 0 
                          AND (t.did LIKE '%$n%')";
            break;

        default:
            echo json_encode(["message" => "Invalid page value"]);
            exit;
    }

    // Execute the user query
    $run_userquery = mysqli_query($conn, $userquery);

    // Check if there are any results
    if (mysqli_num_rows($run_userquery) > 0) {
        $data = [];
        while ($row = mysqli_fetch_array($run_userquery)) {
            $installment_count = 0;

            // Query to count the number of installments based on the page
            switch ($page) {
                case "SakhiCreateLoan":
                    $sakhi_id = $row['id'];
                    $installment_query = "SELECT COUNT(*) as installment_count FROM sakhi_transaction WHERE sid = '$sakhi_id'";
                    $run_installment_query = mysqli_query($conn, $installment_query);
                    $installment_row = mysqli_fetch_array($run_installment_query);
                    $installment_count = $installment_row['installment_count'];
                    break;
                // Add cases for other pages if needed
            }

            $data[] = [
                "id" => $row['id'],
                "name" => $row['name'],
                "phone" => $row['phone'],
                "installment_count" => $installment_count
            ];
        }
        echo json_encode(["message" => "radha", "movie" => $data]);
    } else {
        echo json_encode(["message" => "invalid"]);
    }
} else {
    echo json_encode(["message" => "Parameters 'srch' or 'page' not set"]);
}
?>
