<?php
require ("utils/MiddleWare.php");

// API for loan status

// Admin validation
$admin = $req['aid'];
$auth = $req['auth'];
$a_name = $req['a_name'];

$status = $req['status']; // Loan status
$req_id = $req['req_id']; // Loan request table id
$mid = $req['mid']; // Mandal id
$loan_amount = $req['loan_amount']; // Loan request amount
$remaining = isset($req['interest']) ? $req['interest'] : 0; // Loan interest
$emi = $req['emi']; // Loan per month EMI
$month = $req['month']; // Loan EMI months
$today = date("Y-m-d");
$ltype = $req['loan_type']; // Loan type

// Admin check query
$checkadmin = "SELECT `id` FROM `admin` WHERE `id`='$admin' AND `web_auth`='$auth'";
$get_checkadmin = mysqli_query($conn, $checkadmin);

if (mysqli_num_rows($get_checkadmin) == 1 && $status == "REJECT") {
    // Reject loan
    $query = "UPDATE `loan_req` SET status='$status', aid='$admin', action_date='$today' WHERE id='$req_id'";
    $message = "Your loan was rejected by admin.";

} elseif (mysqli_num_rows($get_checkadmin) == 1 && $status == "ACCEPT") {
    // Accept loan
    if ($ltype == "NEW") {
        // New loan type
        $query = "
            INSERT INTO `loan` (`loan_type`, `mid`, `aid`, `a_name`, `interest`, `loan_amount`, `remaining`, `emi`, `month`, `remaining_month`, `date`)
            VALUES ('$ltype', '$mid', '$admin', '$a_name', '$remaining', '$loan_amount', '$loan_amount', '$emi', '$month', '0', '$today');
            SET @last_id = LAST_INSERT_ID();
            INSERT INTO `transaction` (`loan_id`, `mid`, `aid`, `a_name`, `trans_type`, `emi_type`, `emi_interest`, `payment_mode`, `total`, `date`) 
            VALUES (@last_id, '$mid', '$admin', '$a_name', 'EMI', 'FIRST', '$remaining', 'Self', '$emi', '$today');
            UPDATE `loan_req` SET `loan_id`=@last_id, `amount`='$loan_amount', `aid`='$admin', `action_date`='$today', `status`='$status' WHERE `id`='$req_id';
        ";

        // Prepare loan approval message
        $t_amount = $loan_amount;
        $t_card = $mid;
        $t_final2 = "₹ $t_amount loan created of Scheme 1 - $t_card. \n\nThank you for your continued trust.";
        $message = "Your loan was accepted by admin.";

    } else {
        // Existing loan type
        $query = "
            INSERT INTO `loan` (`loan_type`, `mid`, `aid`, `a_name`, `interest`, `loan_amount`, `remaining`, `emi`, `month`, `remaining_month`, `date`)
            VALUES ('$ltype', '$mid', '$admin', '$a_name', '$remaining', '$loan_amount', '$loan_amount', '$emi', '$month', '0', '$today');
            SET @last_id = LAST_INSERT_ID();
            UPDATE `loan_req` SET `loan_id`=@last_id, `amount`='$loan_amount', `aid`='$admin', `action_date`='$today', `status`='$status' WHERE `id`='$req_id';
        ";
   $t_amount = $loan_amount;
        $t_card = $mid;
        $t_final2 = "₹ $t_amount loan created of Scheme 1 - $t_card. \n\nThank you for your continued trust.";
        $message = "Your loan was accepted by admin.";

    }

} elseif (mysqli_num_rows($get_checkadmin) == 1 && $status === "DELETE") {
    // Delete loan request
    $query = "UPDATE `loan_req` SET status='$status', aid='$admin', action_date='$today' WHERE id='$req_id'";
    $message = "Your loan request was deleted.";

} else {
    // Invalid request
    echo json_encode(["message" => "Invalid"]);
    exit;
}

// Execute the query
if ($conn->multi_query($query) === TRUE) {
    do {
        if ($result = $conn->store_result()) {
            $result->free();
        }
    } while ($conn->more_results() && $conn->next_result());

    // Retrieve mandal user details
    $details = "SELECT * FROM `mandal_user` WHERE `id`='$mid'";
    $rowdets = mysqli_query($conn, $details);

    if ($rowdets && $rundets = mysqli_fetch_array($rowdets)) {
        $idphone = $rundets['phone'];
        mysqli_free_result($rowdets);

        // Send SMS notification
        sendSMS($idphone, $t_final2); // Pass the correct $t_final2 variable

        // Retrieve user details for push notification
        $det = "SELECT * FROM `users` WHERE `phone`='$idphone'";
        $rowdet = mysqli_query($conn, $det);

        if ($rowdet && $rundet = mysqli_fetch_array($rowdet)) {
            $token = $rundet['fireToken'];
            $name = $rundet['name'];
            $notification_message = "Dear $name, $t_final2"; // Ensure $t_final2 is passed here

            if ($token) {
                sendNotification($token, "Scheme 1 - Yami Jewellers", $notification_message, "mandal");
            }
            mysqli_free_result($rowdet);
        }
    }

    // Response
    echo json_encode(["message" => $message]);
} else {
    echo json_encode(["message" => "Invalid query"]);
}
?>
