<?php
// Include TCPDF library
require_once('TCPDF/tcpdf.php');

function createOrderPDF($orderDetails){
    // Create new TCPDF instance with landscape orientation
    $pdf = new TCPDF('L', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

    // Set document information
    $pdf->setCreator(PDF_CREATOR);
    $pdf->setAuthor('Manglik Gold');
    $pdf->setTitle('Order Form');
    $pdf->setSubject('Order Details');
    $pdf->setKeywords('TCPDF, PDF, order, Manglik Gold');

    // Remove default header/footer
    $pdf->setPrintHeader(false);
    $pdf->setPrintFooter(false);

    // Set margins
    $pdf->setMargins(PDF_MARGIN_LEFT, PDF_MARGIN_RIGHT);
    $pdf->setAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

    // Set font
    $pdf->SetFont('helvetica', '', 10);

    // Add a page
    $pdf->AddPage();

    // Define content with a view that matches your order form
    $html = <<<EOD
<div style="border:2px solid black; margin-top:0px; padding:0px !important">
    <img src="logo/logo.png" alt="Logo" style="float: left; width: 100px; height: auto;">
    <h6 style="text-align: center; font-weight: bold; font-size: 18px; color: black; margin: 0;">MANGLIK GOLD</h6>
    <h6 style="text-align: center; font-weight: normal; font-size: 10px; color: black; margin: 0;">34/2 JAY SHREE SWAMINARAYAN NAGAR NIKOL GAM ROAD NIKOL, AHMEDABAD, Mo: 9377735850</h6>
    <h6 style="text-align: center; font-weight: bold; font-size: 13px; color: black; margin: 0;">Order Form</h6>
</div>
<div style="border:1px solid black; padding: 0px;font-size: 10px;">
    <p>&nbsp;&nbsp;&nbsp;&nbsp;<strong>Customer Name:</strong> {$orderDetails['customerName']}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>Order No:</strong> {$orderDetails['orderNo']}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>Date:</strong> {$orderDetails['date']}</p>
    <p>&nbsp;&nbsp;&nbsp;&nbsp;<strong>Mobile No:</strong> {$orderDetails['number']}</p>
</div>
<table border="1" cellpadding="4" cellspacing="0">
    <tr>
        <th>Item Name</th>
        <th>Design</th>
        <th>Size</th>
        <th>Pcs.</th>
        <th>Aprox Gross Wt.</th>
        <th>Aprox Net Wt.</th>
        <th>Metal Rate</th>
    </tr>
EOD;

    // Loop through the items to generate table rows
    foreach ($orderDetails['items'] as $index => $item) {
        $html .= '<tr>';
        $html .= '<td>' . $item['itemName'] . 'Ornament</td>';
        $html .= '<td>' . $item['itemName'] . 'Ornament</td>';
        $html .= '<td>' . $item['itemName'] . 'Ornament</td>';
        $html .= '<td>' . $item['pcs'] . '</td>';
        $html .= '<td>' . $item['grossWt'] . '</td>';
        $html .= '<td>' . $item['netWt'] . '</td>';
        $html .= '<td>' . $item['metalRate'] . '</td>';
        $html .= '</tr>';
    }

    $html .= '<tr><td colspan="5" rowspan="7" ></td><td style="text-align: right;">Metal Rs. : </td><td>'.$orderDetails["mtotal"].'</td></tr>';
    $html .= '<tr><td  style="text-align: right;">Approx Labour Rs. : </td><td>'.$orderDetails["labourRate"].'</td></tr>';
    $html .= '<tr><td  style="text-align: right;">Approx GST Rs. : </td><td>'.$orderDetails["gst"].'</td></tr>';
    $html .= '<tr><td style="text-align: right;">Approx Total Rs. : </td><td>'.$orderDetails["total"].'</td></tr>';
    $html .= '<tr><td style="text-align: right;">Adv. Rs. : </td><td>'.$orderDetails["advance"].' ( '.$orderDetails["percent"].'% )'.'</td></tr>';
    $html .= '<tr><td style="text-align: right;">Approx Baki Rs. : </td><td>'.$orderDetails["remain"].'</td></tr>';
    $html .= '</table>';

    $html .= '<p style="text-align:center; margin-top: 10px;font-size:12px">Customer Signatory &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Authorised Signatory</p>';


    // Print text using writeHTML()
    $pdf->writeHTML($html, true, false, true, false, '');

    // Specify the directory path where you want to save the PDF file (absolute path)
    $directoryPath = __DIR__ . '/ImagesWeb/UploadsPDF/';

    // Create the directory if it doesn't exist
    if (!file_exists($directoryPath)) {
        if (!mkdir($directoryPath, 0777, true)) {
            die('Failed to create directory: ' . $directoryPath);
        }
    }

    // Specify the filename with the directory path
    $filePath = $directoryPath . 'order_' . $orderDetails['orderNo'] . '.pdf';

    // Close and output PDF document to a file path
    $pdf->Output($filePath, 'F');
    
    $path = "https://api.manglikgold.com/API/ImagesWeb/UploadsPDF/order_" . $orderDetails['orderNo'] . ".pdf";

    return $path;
}


?>
